#ifndef ZOOBONX_H
#define ZOOBONX_H

#include "BON.h"
#include "BONImpl.h"
#include "Extensions.h"

///BUP
// add your include files/class definitions here
///EUP

namespace Zoo_BON
{

DECLARE_ABSTRACT_BONEXTENSION( BON::FCO, ThingImpl, Thing );
DECLARE_BONEXTENSION( BON::FCO, aImpl, a );
DECLARE_BONEXTENSION( BON::FCO, bImpl, b );
DECLARE_BONEXTENSION2( BON::Model, a, AbacusImpl, Abacus );
DECLARE_BONEXTENSION4( BON::Reference, b, a, Thing, AbacusUtilizationImpl, AbacusUtilization );


//*******************************************************************
//   C  L  A  S  S   ThingImpl
//*******************************************************************
class ThingImpl :
	  virtual public BON::FCOImpl
{
public:


	///BUP
	// add your own members here
	///EUP
};


//*******************************************************************
//   C  L  A  S  S   aImpl
//*******************************************************************
class aImpl :
	  virtual public BON::FCOImpl
{
public:


	///BUP
	// add your own members here
	///EUP
};


//*******************************************************************
//   C  L  A  S  S   bImpl
//*******************************************************************
class bImpl :
	  virtual public BON::FCOImpl
{
public:


	///BUP
	// add your own members here
	///EUP
};


//*******************************************************************
//   C  L  A  S  S   AbacusImpl
//*******************************************************************
class AbacusImpl :
	  virtual public BON::ModelImpl
	, private aImpl
{
public:


	///BUP
	// add your own members here
	///EUP
};


//*******************************************************************
//   C  L  A  S  S   AbacusUtilizationImpl
//*******************************************************************
class AbacusUtilizationImpl :
	  virtual public BON::ReferenceImpl
	, public bImpl
	, public aImpl
	, public ThingImpl
{
public:

	//
	// ref getters
	virtual Abacus      getAbacus();

	///BUP
	// add your own members here
	///EUP
};



}; // namespace Zoo_BON

///BUP
// add your additional class definitions here
///EUP

#endif // ZOOBONX_H
